<template>
  <b-modal
    :model-value="modelValue"
    :title="title"
    :hide-footer="true"
    @update:modelValue="$emit('update:modelValue', modelValue)"
    @hidden="hideModal"
  >
    <div class="v_gapped_container">
      <div>
        {{ body }}
      </div>
      <slot />
      <div class="mt-4">
        <slot name="buttons" />
      </div>
    </div>
  </b-modal>
</template>

<script lang="ts">
import type { TranslateResult } from "vue-i18n";

export default defineComponent({
  name: "CoscineModal",
  props: {
    modelValue: {
      default: false,
      type: Boolean,
    },
    title: {
      default: "",
      type: [String, Object] as PropType<string | TranslateResult | undefined>,
    },
    body: {
      default: "",
      type: [String, Object] as PropType<
        string | TranslateResult | null | undefined
      >,
    },
  },
  methods: {
    hideModal() {
      this.$emit("update:modelValue", false);
    },
  },
});
</script>

<style>
.modal-dialog {
  top: 4rem;
}
</style>
